/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import java.util.Calendar;
import java.util.List;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Messagebox;

import com.rjconsultores.ventaboletos.entidad.TipoServicio;
import com.rjconsultores.ventaboletos.service.TipoServicioService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextbox;

/**
 * 
 * @author Rafius
 */
@Controller("editarTipoServicioController")
@Scope("prototype")
public class EditarTipoServicioController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	private static Logger log = Logger.getLogger(EditarTipoServicioController.class);

	@Autowired
	private TipoServicioService tipoServicioService;

	private TipoServicio tipoServicio;
	private MyListbox tipoServicioList;
	private MyTextbox txtNome;
	private Button btnApagar;

	public Button getBtnApagar() {
		return btnApagar;
	}

	public void setBtnApagar(Button btnApagar) {
		this.btnApagar = btnApagar;
	}

	public MyTextbox getTxtNome() {
		return txtNome;
	}

	public void setTxtNome(MyTextbox txtNome) {
		this.txtNome = txtNome;
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);

		tipoServicio = (TipoServicio) Executions.getCurrent().getArg().get("tipoServicio");
		tipoServicioList = (MyListbox) Executions.getCurrent().getArg().get("tipoServicioList");

		if (tipoServicio.getTiposervicioId() == null) {
			btnApagar.setVisible(Boolean.FALSE);
		}

		txtNome.focus();
	}

	public void onClick$btnSalvar(Event ev) throws InterruptedException {
		txtNome.getValue();
		try {

			tipoServicio.setActivo(Boolean.TRUE);
			tipoServicio.setFecmodif(Calendar.getInstance().getTime());
			tipoServicio.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

			List<TipoServicio> lsTipoServicio = tipoServicioService.buscar(tipoServicio.getDescservicio());

			if (!lsTipoServicio.isEmpty() && tipoServicio.getTiposervicioId() == null) {
				Messagebox.show(
						Labels.getLabel("MSG.Registro.Existe"),
						Labels.getLabel("editarTipoServicioController.window.title"),
						Messagebox.OK, Messagebox.EXCLAMATION);
			} else {
				if (tipoServicio.getTiposervicioId() == null) {
					tipoServicioService.suscribir(tipoServicio);
					tipoServicioList.addItem(tipoServicio);
				} else {
					tipoServicioService.actualizacion(tipoServicio);
					tipoServicioList.updateItem(tipoServicio);
				}

				Messagebox.show(
						Labels.getLabel("editarTipoServicioController.MSG.suscribirOK"),
						Labels.getLabel("editarTipoServicioController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);

				closeWindow();
			}
		} catch (Exception ex) {
			log.error("Exception ao suscribir TipoServicio: " + ex);
			Messagebox.show(
					Labels.getLabel("MSG.Error"),
					Labels.getLabel("editarTipoServicioController.window.title"),
					Messagebox.OK, Messagebox.ERROR);
		}
	}

	public void onClick$btnApagar(Event ev) {
		try {
			int resp = Messagebox.show(
					Labels.getLabel("editarTipoServicioController.MSG.borrarPergunta"),
					Labels.getLabel("editarTipoServicioController.window.title"),
					Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

			if (resp == Messagebox.YES) {

				tipoServicioService.borrar(tipoServicio);

				Messagebox.show(
						Labels.getLabel("editarTipoServicioController.MSG.borrarOK"),
						Labels.getLabel("editarTipoServicioController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);

				tipoServicioList.removeItem(tipoServicio);

				closeWindow();
			}
		} catch (Exception ex) {
			log.error(ex);
		}
	}

	public TipoServicio getTipoServicio() {
		return tipoServicio;
	}

	public void setTipoServicio(TipoServicio tipoServicio) {
		this.tipoServicio = tipoServicio;
	}

	public MyListbox getTipoServicioList() {
		return tipoServicioList;
	}

	public void setTipoServicioList(MyListbox tipoServicioList) {
		this.tipoServicioList = tipoServicioList;
	}

	public TipoServicioService getTipoServicioService() {
		return tipoServicioService;
	}

	public void setTipoServicioService(TipoServicioService tipoServicioService) {
		this.tipoServicioService = tipoServicioService;
	}
}
